/*
 * Configuration file for m68k based machine running NetBSD.
 */

#define HAVE_68881

/* Define BPT_VECTOR if it is different than the default.
   This is the vector number used by traps to indicate a breakpoint. */

#define BPT_VECTOR 0x2

#define TARGET_NBPG 8192
#define TARGET_UPAGES 2

/* Address of end of stack space.  */

#define STACK_END_ADDR 0x0f000000	/* USRSTACK */

/* In NetBSD on the Amiga, the signal trampoline is at the bottom
   of the user's stack, right after (i.e., lower in memory than)
   the ps_strings structure.
   Since we're can't require that the NetBSD-Amiga include files
   are around anywhere (and I don't really want to look up the
   values of _sigcode and _esigcode in /vmunix), the size of
   ps_strings and the trampoline code is hard-coded. */

#define PS_STRINGS_SIZE	16
#define TRAMPOLINE_SIZE	18

#define IN_SIGTRAMP(pc, name) \
  ((pc) >= (STACK_END_ADDR - PS_STRINGS_SIZE - TRAMPOLINE_SIZE) \
   && (pc) < STACK_END_ADDR)

#include "tm-netbsd.h"
#include "m68k/tm-m68k.h"
